'use strict'

const mssql = require('./')

const sqlConfig = {
  password: 'Upper_l0wercase',
  database: 'di_production',
  // connectionTimeout: undefined,
  // requestTimeout: 30000,
  stream: false,
  options: {
    encrypt: true,
    readOnlyIntent: true
  },
  port: 1433,
  user: 'sa',
  server: 'localhost',
  pool: {
    acquireTimeoutMillis: 1000,
    propagateCreateError: true,
  },
}

let pool

function createPool() {
  return new mssql.ConnectionPool(sqlConfig)
}

const poolRequest = createPool()

function connect () {
  console.log('trying to connect to server')
  // const poolRequest = createPool()
  mssql.on('error', () => {
    console.log('error event fired')
  })
  return poolRequest.connect(sqlConfig).then((connection) => {
    // setTimeout(connection.close.bind(connection), 2000)
    console.log('connection established')
    console.log(connection)
    connection.on('error', (e) => {
      console.error(e)
    })
    pool = connection
  }).catch((e) => {
    console.error(e)
    throw e
  })
}

Object.prototype.validate = () => {

};

connect()
  .then(() => {
    const request = pool.request()
    return request.query('SELECT * FROM institution')
  })
  .then((result) => {
    console.log(result)
  })
  .catch((e) => {
    console.error(e)
  })
  .then(() => {
    return pool.close()
  })
